using System;
using System.Text;
using System.Net;
using System.IO;
using System.Collections;

using WebImageLib;

namespace WISGoogle
{
	public class GoogleImage : IWebImage
	{
		static Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");		

		int currentPage;
		bool hasNext;
		
		// filter=0tȂƁAQy[WڂłʂɂȂ
		string url = "http://images.google.co.jp/images?hl=ja&q={0}&start={1}&filter=0&safe=off";

		public GoogleImage()
		{
			Reset();
		}

		string readPage(string u) 
		{
			string html = "";
			WebClient wc = null;
			Stream st = null;
			StreamReader sr = null;
			try 
			{
				wc = new WebClient();
				st = wc.OpenRead(u);
				sr = new StreamReader(st, sjisEnc);
				html = sr.ReadToEnd();
			} 
			finally 
			{
				if (sr != null) sr.Close();
				if (st != null) st.Close();
				if (wc != null) wc.Dispose();
			}
			return html;
		}

		#region IWebImage o

		public WebImage[] GetImages(string query)
		{
			ArrayList images = new ArrayList();
			if (query != "")
			{
				string html = readPage(
					String.Format(url, System.Web.HttpUtility.UrlEncode(query, sjisEnc), currentPage * 20));

				string[] src = html.Split(' ');

				// srcz̓e
				// href=/imgres?imgurl=http://www.charlespetzold.com/key/keycs.jpg&imgrefurl=http://www.charlespetzold.com/key/&h=475&w=389&sz=25&tbnid=sDYnpda4B2EJ:&tbnh=126&tbnw=103&hl=ja&start=3&prev=/images%3Fq%3Dc%2523%26hl%3Dja%26lr%3D%26sa%3DG><img
				// src=/images?q=tbn:sDYnpda4B2EJ:www.charlespetzold.com/key/keycs.jpg

				for (int i = 0; i < src.Length; i++)
				{
					if (i + 1 < src.Length
						&& src[i].StartsWith("href=/imgres?")
						&& src[i + 1].StartsWith("src=/images?"))
					{
						string small = "http://www.google.co.jp" + src[i + 1].Substring(4);

						string[] tmp = src[i].Split('&');

						// tmpz̓e						
						// href=/imgres?imgurl=http://www.charlespetzold.com/key/keycs.jpg
						// imgrefurl=http://www.charlespetzold.com/key/
						// h=475
						// w=389 EEE
						string large = tmp[0].Substring(20);
						string page = tmp[1].Substring(10);

						images.Add(new WebImage(small, large, page));
					}
				}
				// uցṽNEeLXg`FbN
				hasNext = html.IndexOf("<span class=b><b></b></span>") == -1 ? false : true;
			}
			return (WebImage[])images.ToArray(typeof(WebImage)); // zɕϊ
		}

		public int CurrentPage
		{
			get { return currentPage + 1; }
		}

		public string Name
		{
			get { return "Google"; }
		}

		public bool MoveNext()
		{
			if (hasNext) 
			{
				currentPage++;
			}
			return hasNext;
		}

		public void Reset() 
		{
			hasNext = false;
			currentPage = 0;
		}

		#endregion

		public class GoogleTest
		{
			static void Main()
			{
				string query = "c#";
				IWebImage google = new GoogleImage();

				do 
				{
					foreach (WebImage wi in google.GetImages(query))
					{
						Console.WriteLine(google.CurrentPage);
						Console.WriteLine(wi.SmallImageURL);
						Console.WriteLine(wi.LargeImageURL);
						Console.WriteLine(wi.DetailPageURL);
					}
				} while (google.MoveNext());			
			}
		}
	}
}
